#!/usr/bin/perl

# 

# Start script for genome wide Family Based Association Test (FBAT), chromosome by chromosome 
# (c) 2005 Franz Rueschendorf 

# usage: perl fbat_start.pl

use Cwd;
use strict;

# foreach my $chr ("01"){ 	# for one chromosome 

foreach my $chr ("01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24") {
	if ( -d "c$chr") {

		chdir "c${chr}";
		print "Chromosome $chr\n";
		if (-f "fbat_log.${chr}") {unlink "fbat_log.$chr";}
		
		open (OUT,">fbat.in") || die "could not open fbat.in :$!\n";

		print OUT "log fbat_log.$chr\n";		
		print OUT "load ped pedin.$chr\n"; 

	# Edit FBAT options here
		print OUT "mode\n";		
		print OUT "model a\n";		
		print OUT "fbat -e\n";		
		print OUT "model d\n";		
		print OUT "fbat -e\n";		
		print OUT "model r\n";		
		print OUT "fbat -e\n";		
		print OUT "model g\n";		
		print OUT "fbat\n";		
		print OUT "\nq\n";		

		close (OUT);

		my $command="fbat < fbat.in";
		system ("$command");
		chdir  ".." ;
	}
}
