#!/usr/bin/perl

##############################################
#
# Tim M Strom March 2005
#
##############################################

use strict;
use Getopt::Long;

my @line         = ();
my %HoH          = (); #hash of hashes containg calls
my %HoHscore     = (); #hash of hashes containg scores
my $snp          = "";
my $person       = "";
my $persons      = "";
my $line         = "";
my $outFile      = "";
my $countPersons = 0;
my %scoreAll     = (); #hash for counting score histogram
my $score        = "";
my $minscore     = -1;
my $sumSNPs      = 0;
my $percent      = 0;
my $percent30    = 0;
my $percent40    = 0;
my $percent50    = 0;
my $infile       = "";
my $help         = 0;
my $scoreToLow   = 0;
my $deleted      = 0;
my %qualityPerPerson = ();

GetOptions("i=s" => \$infile,"s=s" => \$minscore, 
"h" => \$help);
if (($help == 1) or ($infile eq "")) {
print 
"-i <name of the inputfile containing the calls> 
-s <minimum score>
-h (this help)\n";
exit(1);
}

open (IN, "$infile");
open (OUT, ">all_out.csv");

while (<IN>) {
	chomp;
	if (/^rs\d/) {
		@line=split(/\,/);
		if ($line[4]<=$minscore) {
			$scoreToLow++;
			#print "@line\n";
			if ($line[2] ne "*") {
				$deleted++;
			}
			$line[2] = "NoCall";
			$line[3] = "";
		}
		if ($line[2] eq "*"){
			$line[2] = "NoCall";
			$line[3] = "";
		}
		$HoH{$line[0]}{ $line[1]}="$line[2]$line[3]";
		$HoHscore{$line[0]}{ $line[1]}="$line[4]";
	}
}

print OUT "SNP ID\t";

foreach $snp (keys %HoH) {
	$outFile .= "$snp\t";
	$persons  = "";
	$line     = "";
	$countPersons = 0;
	for $person (sort keys %{ $HoH{$snp} }) {
		$persons .= "$person\t";
		$line    .= "$HoH{$snp}{$person}\t";
		$countPersons++;
	}
	chop($line);
	$line .= "\n";
	$outFile .= "$line";
}
chop($persons);
$persons .= "\n";
print OUT $persons;
print OUT $outFile;

# count quality score for all SNPs
foreach $snp (keys %HoHscore) {
	for $person (sort keys %{ $HoH{$snp} }) {
		if ($HoHscore{$snp}{$person} <= 0.3) {
			$qualityPerPerson{$person}{30}++;
		}
		if ($HoHscore{$snp}{$person} <= 0.4) {
			$qualityPerPerson{$person}{40}++;
		}
		if ($HoHscore{$snp}{$person} <= 0.5) {
			$qualityPerPerson{$person}{50}++;
		}
		if ($HoHscore{$snp}{$person} <= $minscore) {
			$qualityPerPerson{$person}{$minscore}++;
		}
		if ($HoHscore{$snp}{$person} <= 0.1) {
			$scoreAll{"0.00-0.10"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.2) {
			$scoreAll{"0.10-0.20"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.3) {
			$scoreAll{"0.20-0.30"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.4) {
			$scoreAll{"0.30-0.40"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.5) {
			$scoreAll{"0.40-0.50"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.6) {
			$scoreAll{"0.50-0.60"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.7) {
			$scoreAll{"0.60-0.70"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.8) {
			$scoreAll{"0.70-0.80"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 0.9) {
			$scoreAll{"0.80-0.90"}++;
			$sumSNPs++;
		}
		elsif ($HoHscore{$snp}{$person} <= 1.0) {
			$scoreAll{"0.90-1.00"}++;
			$sumSNPs++;
		}
	}	
}
print "CountPersons = $countPersons\n";
print "Minscore $minscore\n";
$percent=$scoreToLow/$sumSNPs;
printf("Score_to_low %8s (%.3f)\n", $scoreToLow, $percent);
$percent=$deleted/$sumSNPs;
printf("Deleted      %8s (%.3f)\n", $deleted, $percent);

print "\nCall_quality\n";
foreach $score (sort keys %scoreAll) {
	$percent=$scoreAll{$score}/$sumSNPs;
	printf("%s %8s (%.3f)\n",  $score, $scoreAll{$score}, $percent);
}
printf("Sum %14s\n", $sumSNPs);

print "\nGC_score_per_person_sorted_by_Id\nId <=0.5 <=0.4 <=0.3 <=$minscore\n";
foreach $person (sort keys %qualityPerPerson) {
	$percent30=$qualityPerPerson{$person}{30}/$sumSNPs*$countPersons;
	$percent40=$qualityPerPerson{$person}{40}/$sumSNPs*$countPersons;
	$percent50=$qualityPerPerson{$person}{50}/$sumSNPs*$countPersons;
	$percent=$qualityPerPerson{$person}{$minscore}/$sumSNPs*$countPersons;
	printf("%s %8s (%.3f) %8s (%.3f) %8s (%.3f) %8s (%.3f)\n",  $person, $qualityPerPerson{$person}{50}, $percent50, $qualityPerPerson{$person}{40}, $percent40, $qualityPerPerson{$person}{30}, $percent30, $qualityPerPerson{$person}{$minscore}, $percent);
	#print "$person $qualityPerPerson{$person}\n";
}
print "\nGC_score_per_person_sorted_by_<=0.50\nId <=0.5 <=0.4 <=0.3 <=$minscore\n";
foreach $person (sort {$qualityPerPerson{$a}{50} <=> $qualityPerPerson{$b}{50} } keys %qualityPerPerson) {
	$percent30=$qualityPerPerson{$person}{30}/$sumSNPs*$countPersons;
	$percent40=$qualityPerPerson{$person}{40}/$sumSNPs*$countPersons;
	$percent50=$qualityPerPerson{$person}{50}/$sumSNPs*$countPersons;
	$percent=$qualityPerPerson{$person}{$minscore}/$sumSNPs*$countPersons;
	printf("%s %8s (%.3f) %8s (%.3f) %8s (%.3f) %8s (%.3f)\n",  $person, $qualityPerPerson{$person}{50}, $percent50, $qualityPerPerson{$person}{40}, $percent40, $qualityPerPerson{$person}{30}, $percent30, $qualityPerPerson{$person}{$minscore}, $percent);
	#print "$person $qualityPerPerson{$person}\n";
}
close IN;
close OUT;

