#!/usr/bin/perl

# Start script for genome-wide Plink scan, chromosome by chromosome, no moving window 
# (c) 2006 Franz Rueschendorf 

# usage: perl plink_start.pl

use Cwd;
use strict;

my $command="";

# foreach my $chr ("01"){		# use this line when one or some chromosomes should be calculated

foreach my $chr ("01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24") {
	if ( -d "c$chr") {
		
		chdir "c${chr}";
		print "Calculate chromosome $chr\n";


#---------------------- delete old files  ----------------------#

		if (-f "plink.tdt") {unlink "plink.tdt";}
		unlink glob("*.out");


#------------------ modify plink commands here -----------------#  

		# start TDT test and estimate p-value with permutation
		
		$command = "plink --ped pedin.$chr --map plink_map.$chr --tdt --perm > plink.out";

		system ("$command");

		
#--------------------- end edit plink commands -----------------#

		chdir  ".." ;
	}
}
