#!/usr/bin/perl
#
# GH_SNP_QTL_START.PL
# Start script for genome wide Genehunter runs, with moving window
# (c) 2005 Franz Rueschendorf 

# this script uses the Kosambi function

use Cwd;
use strict;
use File::Copy;
use File::Basename;

my @files=();
my $setup="";
my $gh="gh2";	# name of Genehunter executable
my $xgh="xghi";	# name of Genehunter for X-linked data
my $prog="";


# foreach my $chr ("21") {	# test

foreach  my $chr ("01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24") {
	if ( -d "c$chr") {
		
		chdir "c${chr}";
		if ($chr == 23) {$prog ="$xgh";} else {$prog="$gh";}
		print "Chromosome $chr\n";
		unlink glob("*.ps");
		unlink glob("*.out");
		unlink glob("setup*");
		my $set=0;	# counter sets
		@files=glob("datain_*.${chr}");
		
		foreach (@files){
			my $basename=basename($_);
			my @feld =	split('_',$basename);
			if ($set < $feld[1]) {$set=$feld[1];}
		}
		foreach my $i ( 1..$set) {
			$setup = "setup_${i}.${chr}";
			open (OUT,"> $setup") || die "could not open $setup :$!\n";

			# ---- Edit Genehunter options here ---- #
			print OUT "photo gh_${i}.out\n";
			print OUT "map func kosambi\n";
			print OUT "load markers datain_${i}.${chr}\n";
			print OUT "units\n";
			print OUT "haplo off\n";
			print OUT "display scores off\n";
			print OUT "off end\n";
			print OUT "increment step 2\n";
			print OUT "\n";
			print OUT "scan pedin_${i}.${chr}\n"; 
			print OUT "display scores on\n";
			print OUT "ps off\n";
			print OUT "total stat het\n";
			print OUT "\n\n\n\n\n";
			print OUT "ps on\n";
			print OUT "haseman elston\n";
			print OUT "trad-he_${i}.out\n";
			print OUT "em-he_${i}.out\n";
			print OUT "he_${i}.ps\n";
			print OUT "\n\n";
			print OUT "ml variance\n";
			print OUT "ml_${i}.out\n";
			print OUT "ml_${i}.ps\n";
			print OUT "\n\n";
			print OUT "no dom var\n";
			print OUT "ml_ndv_${i}.out\n";
			print OUT "ml_ndv_${i}.ps\n";
			print OUT "\n\n";
			print OUT "nonparametric\n";
			print OUT "np_${i}.out\n";
			print OUT "np_${i}.ps\n";
			print OUT "\n\n";
#			print OUT "variance components\n";
#			print OUT "y\n";
#			print OUT "y\n";
#			print OUT "vc_${i}.out\n";
#			print OUT "corr_${i}.out\n";
#			print OUT "vc_lod_${i}.ps\n";
#			print OUT "vc_var_${i}.ps\n";
#			print OUT "n\n";
			print OUT "\n\n";
			print OUT "q\n";
			print OUT "\n";
			
			# ---- End edit Genehunter options ---- #
			close (OUT);

#			my $command="$prog < ${setup} > /dev/null";	# UNIX
			my $command="$prog < ${setup} > nul";		# DOS
			system ("$command"); 
		}
		chdir  ".." ;
	}
	else {
		print "no chromosome $chr\n";
	}
}

